#ifndef MYEC2_H_INCLUDED
#define MYEC2_H_INCLUDED

#include "stdafx.h"



namespace MyS3MultiPartUploader
{
	struct PartDesc
	{
		size_t partId;
		string md5;
		string eTag;
		size_t offset;
		size_t size;
	};

	//typedef map<size_t, PartDesc> IndexPartDescMap;
	typedef vector<PartDesc> PartDescVector;

	struct MultiPartDesc
	{
		string bucket;
		string object;
		FILE*  stream;
		string uploadId;
		size_t partCount;
		PartDescVector partDescVector;
	};

    class MyS3
    {
        friend int mySimpleXmlCallback(const char *elementPath, const char *data, int dataLen, void *callbackData);
    private:
		static char* HttpVerb[3];

        static char accessKey[32];
        static char secretAccessKey[64];
        static char keyPath[256];
        static bool isKeyOK;
        //char ip[32];
        MultiPartDesc multiPartDesc;
        void initializeKey(const char* newKeyPath);
        bool initialize(const string& bucketName, const string& objectName, const string& fileName, size_t nSuggestedPartNumber);

        bool readKeyFile();

        std::string getTimestamp();
        bool initMultiPartUpload();

    public:
        StringPairVector resultSet;
        //StringPairVector paramSet;
        MyS3(char* newKeyPath = NULL);
        bool multiPartUpload(const string& bucketName, const string& objectName, const string& fileName, size_t nSuggestedPartNumber);
    };

}


#endif // MYEC2_H_INCLUDED
